// Global constants
var PWDBANK_DIV_ID = "PwdBankDIVElementId45697315";
var PWDBANK_OBJ_ID = "PwdBankOBJElementId45697315";
var PWDBANK_SUBMITBTN_ID = "462158PwdBankSubmit";
var PWDBANK_SUBMITTEDFORM_ID = "p-aPwdBankSubmittedForm";
var PWDBANK_ACTIVEBTN_ID = "462158PwdBankTabActive";
var PWDBANK_INACTIVEBTN_ID = "462158PwdBankTabInactive";

function setTabActive(how)
{
  var pwdBankObj = document.getElementById(PWDBANK_OBJ_ID);
  console.log("setTabActive: " + how + ", PwdBankObj " + pwdBankObj);
  if(typeof pwdBankObj === 'undefined' || null == pwdBankObj)
  {
     console.log("pwdBankObj undefined");
     return; // PwdBank object is not available
  }     
  try
  {
    pwdBankObj.setTabActive(how);
  }
  catch(ex)
  {
    console.error("setTabActive exception: " + ex);
  }
}

function callPluginSubmittedForm()
{
  try{
    document.getElementById(PWDBANK_OBJ_ID).SubmittedForm(null);
  }catch(e){console.log(e);}  
}

function OnSubmitHandler(sender)
{   
   console.log("OnSubmitHandler " + sender.target);
   try   
   {
      var el = document.getElementById(PWDBANK_OBJ_ID);
      if(typeof el === 'undefined')
      {
         console.error("onSubmit - no PwdBank found");
         return; // PwdBank object is not available
      }
      
      if(typeof sender === 'undefined')
      {
         console.error("onSubmit - no sender specified");
         return; // no sender was provided, probably form submitted by Javascript
      }
        
      var frm = sender.target;
      var cnt = frm.elements.length;
      for(var i = 0; i < cnt; ++i)
      {
         if("password" == frm.elements[i].type)
         {
            frm.setAttribute(PWDBANK_SUBMITTEDFORM_ID, "1");                    
            document.getElementById(PWDBANK_SUBMITBTN_ID).click();  // to allow submit call to be in the document context, not the add-on context
            frm.setAttribute(PWDBANK_SUBMITTEDFORM_ID, "");
            break;
         }
      }
   }
   catch(ex)
   {
     console.log("OnSubmitHandler exception " + ex);      
   }
   return;   
}

function addScript(url)
{
   var headID = document.getElementsByTagName("head")[0];
   var newScript = document.createElement('script');
   newScript.type = 'text/javascript';
   newScript.src = url;
   headID.appendChild(newScript);
}

function startPwdBank()
{
  if (window.frameElement) return;
  
  try
  {
   var el = document.getElementById(PWDBANK_OBJ_ID);
   if(el)
   {
      console.log('InstallPwdBank already done');
      return; // PwdBank element is already installed
   }
   var injectCode = "<div id='" + PWDBANK_DIV_ID + "' style='display: block; width:1px; height:1px;'><embed id='" + PWDBANK_OBJ_ID +"' width=1 height=1 type='application/pwdbank-ff-plugin' name='PwdBank' allowscriptaccess='always'></div>";  
   injectCode += "<input type='button' value='Active' id='" + PWDBANK_ACTIVEBTN_ID + "' onclick='setTabActive(true);' style='display:none;'></input>";
   injectCode += "<input type='button' value='Inactive' id='" + PWDBANK_INACTIVEBTN_ID + "' onclick='setTabActive(false);' style='display:none;'></input>";
   injectCode += "<input type='button' value='Submit' id='" + PWDBANK_SUBMITBTN_ID + "' onclick='callPluginSubmittedForm();' style='display:none;'></input>";
   
   
      
   document.body.insertAdjacentHTML("beforeEnd", injectCode);        
   
   var pwdBankObj = document.getElementById(PWDBANK_OBJ_ID);
   if(!pwdBankObj)
   {  
      document.body.insertAdjacentHTML("afterEnd", injectCode);
      pwdBankObj = document.getElementById(PWDBANK_OBJ_ID);
   }   
  }
  catch(ex)
  {
    console.log("PwdBank won't work on this page, exception: " + ex);
  }
}
